use ::libc;

pub use crate::stddef_h::size_t;

pub use crate::stdlib::_IO_codecvt;
pub use crate::stdlib::_IO_lock_t;
pub use crate::stdlib::_IO_marker;
pub use crate::stdlib::_IO_wide_data;
pub use crate::stdlib::__int32_t;
pub use crate::stdlib::__off64_t;
pub use crate::stdlib::__off_t;
pub use crate::stdlib::__uint32_t;
pub use crate::stdlib::__uint8_t;
pub use crate::stdlib::int32_t;
pub use crate::stdlib::FILE;
pub use crate::stdlib::_IO_FILE;

pub use crate::squeezelite_h::_apply_cross;
pub use crate::squeezelite_h::buffer;
pub use crate::squeezelite_h::fade_dir;
pub use crate::squeezelite_h::fade_mode;
pub use crate::squeezelite_h::fade_state;
pub use crate::squeezelite_h::frames_t;
pub use crate::squeezelite_h::lDEBUG;
pub use crate::squeezelite_h::lERROR;
pub use crate::squeezelite_h::lINFO;
pub use crate::squeezelite_h::lSDEBUG;
pub use crate::squeezelite_h::lWARN;
pub use crate::squeezelite_h::log_level;
pub use crate::squeezelite_h::output_format;
pub use crate::squeezelite_h::output_state;
pub use crate::squeezelite_h::outputstate;
pub use crate::squeezelite_h::s32_t;
pub use crate::squeezelite_h::u32_t;
pub use crate::squeezelite_h::u8_t;
pub use crate::squeezelite_h::C2RustUnnamed_1;
pub use crate::squeezelite_h::FADE_ACTIVE;
pub use crate::squeezelite_h::FADE_CROSS;
pub use crate::squeezelite_h::FADE_CROSSFADE;
pub use crate::squeezelite_h::FADE_DOWN;
pub use crate::squeezelite_h::FADE_DUE;
pub use crate::squeezelite_h::FADE_IN;
pub use crate::squeezelite_h::FADE_INACTIVE;
pub use crate::squeezelite_h::FADE_INOUT;
pub use crate::squeezelite_h::FADE_NONE;
pub use crate::squeezelite_h::FADE_OUT;
pub use crate::squeezelite_h::FADE_UP;
pub use crate::squeezelite_h::OUTPUT_BUFFER;
pub use crate::squeezelite_h::OUTPUT_OFF;
pub use crate::squeezelite_h::OUTPUT_PAUSE_FRAMES;
pub use crate::squeezelite_h::OUTPUT_RUNNING;
pub use crate::squeezelite_h::OUTPUT_SKIP_FRAMES;
pub use crate::squeezelite_h::OUTPUT_START_AT;
pub use crate::squeezelite_h::OUTPUT_STOPPED;
pub use crate::squeezelite_h::S16_LE;
pub use crate::squeezelite_h::S24_3LE;
pub use crate::squeezelite_h::S24_LE;
pub use crate::squeezelite_h::S32_LE;
pub use crate::src::output::_output_frames;
pub use crate::src::output::output_close_common;
pub use crate::src::output::output_init_common;
pub use crate::src::output_pack::_scale_and_pack_frames;
pub use crate::src::utils::gettime_ms;
pub use crate::src::utils::logprint;
pub use crate::src::utils::logtime;
pub use crate::stdlib::__pthread_internal_list;
pub use crate::stdlib::__pthread_list_t;
pub use crate::stdlib::__pthread_mutex_s;
use crate::stdlib::free;
use crate::stdlib::fwrite;
use crate::stdlib::malloc;
use crate::stdlib::memset;
use crate::stdlib::pthread_attr_destroy;
use crate::stdlib::pthread_attr_init;
use crate::stdlib::pthread_attr_setstacksize;
pub use crate::stdlib::pthread_attr_t;
use crate::stdlib::pthread_create;
use crate::stdlib::pthread_mutex_lock;
pub use crate::stdlib::pthread_mutex_t;
use crate::stdlib::pthread_mutex_unlock;
pub use crate::stdlib::pthread_t;
use crate::stdlib::stdout;
use crate::stdlib::strcmp;
pub use crate::stdlib::u_int32_t;
pub use crate::stdlib::u_int8_t;
extern "C" {
    #[no_mangle]
    pub static mut output: crate::squeezelite_h::outputstate;
    #[no_mangle]
    pub static mut outputbuf: *mut crate::squeezelite_h::buffer;
    #[no_mangle]
    pub static mut silencebuf: *mut crate::squeezelite_h::u8_t;
}

static mut loglevel: crate::squeezelite_h::log_level = crate::squeezelite_h::lERROR;

static mut running: bool = 1 as libc::c_int != 0;
// buffer to hold output data so we can block on writing outside of output lock, allocated on init

static mut buf: *mut crate::squeezelite_h::u8_t =
    0 as *const crate::squeezelite_h::u8_t as *mut crate::squeezelite_h::u8_t;

static mut buffill: libc::c_uint = 0;

static mut bytes_per_frame: libc::c_int = 0;

unsafe extern "C" fn _stdout_write_frames(
    mut out_frames: crate::squeezelite_h::frames_t,
    mut silence: bool,
    mut gainL: crate::squeezelite_h::s32_t,
    mut gainR: crate::squeezelite_h::s32_t,
    mut cross_gain_in: crate::squeezelite_h::s32_t,
    mut cross_gain_out: crate::squeezelite_h::s32_t,
    mut cross_ptr: *mut *mut crate::squeezelite_h::s32_t,
) -> libc::c_int {
    let mut obuf = 0 as *mut crate::squeezelite_h::u8_t;
    if !silence {
        if output.fade as libc::c_uint
            == crate::squeezelite_h::FADE_ACTIVE as libc::c_int as libc::c_uint
            && output.fade_dir as libc::c_uint
                == crate::squeezelite_h::FADE_CROSS as libc::c_int as libc::c_uint
            && !(*cross_ptr).is_null()
        {
            crate::squeezelite_h::_apply_cross(
                outputbuf,
                out_frames,
                cross_gain_in,
                cross_gain_out,
                cross_ptr,
            );
        }
        obuf = (*outputbuf).readp
    } else {
        obuf = silencebuf
    }
    crate::src::output_pack::_scale_and_pack_frames(
        buf.offset(buffill.wrapping_mul(bytes_per_frame as libc::c_uint) as isize)
            as *mut libc::c_void,
        obuf as *mut libc::c_void as *mut crate::squeezelite_h::s32_t,
        out_frames,
        gainL,
        gainR,
        output.format,
    );
    buffill = buffill.wrapping_add(out_frames);
    return out_frames as libc::c_int;
}

unsafe extern "C" fn output_thread() -> *mut libc::c_void {
    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
    match output.format as libc::c_uint {
        0 => bytes_per_frame = 4 as libc::c_int * 2 as libc::c_int,
        2 => bytes_per_frame = 3 as libc::c_int * 2 as libc::c_int,
        3 => bytes_per_frame = 2 as libc::c_int * 2 as libc::c_int,
        _ => bytes_per_frame = 4 as libc::c_int * 2 as libc::c_int,
    }
    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
    while running {
        crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
        output.device_frames = 0 as libc::c_int as libc::c_uint;
        output.updated = crate::src::utils::gettime_ms();
        output.frames_played_dmp = output.frames_played;
        crate::src::output::_output_frames(2048 as libc::c_int as crate::squeezelite_h::frames_t);
        crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
        if buffill != 0 {
            crate::stdlib::fwrite(
                buf as *const libc::c_void,
                bytes_per_frame as libc::c_ulong,
                buffill as libc::c_ulong,
                crate::stdlib::stdout,
            );
            buffill = 0 as libc::c_int as libc::c_uint
        }
    }
    return 0 as *mut libc::c_void;
}

static mut thread: crate::stdlib::pthread_t = 0;
#[no_mangle]

pub unsafe extern "C" fn output_init_stdout(
    mut level: crate::squeezelite_h::log_level,
    mut output_buf_size: libc::c_uint,
    mut params: *mut libc::c_char,
    mut rates: *mut libc::c_uint,
    mut rate_delay: libc::c_uint,
) {
    loglevel = level;
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d init output stdout\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 19], &[libc::c_char; 19]>(b"output_init_stdout\x00"))
                .as_ptr(),
            130 as libc::c_int,
        );
    }
    buf = crate::stdlib::malloc((2048 as libc::c_int * 8 as libc::c_int) as libc::c_ulong)
        as *mut crate::squeezelite_h::u8_t;
    if buf.is_null() {
        crate::src::utils::logprint(
            b"%s %s:%d unable to malloc buf\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 19], &[libc::c_char; 19]>(b"output_init_stdout\x00"))
                .as_ptr(),
            134 as libc::c_int,
        );
        return;
    }
    buffill = 0 as libc::c_int as libc::c_uint;
    crate::stdlib::memset(
        &mut output as *mut crate::squeezelite_h::outputstate as *mut libc::c_void,
        0 as libc::c_int,
        ::std::mem::size_of::<crate::squeezelite_h::outputstate>() as libc::c_ulong,
    );
    output.format = crate::squeezelite_h::S32_LE;
    output.start_frames = (2048 as libc::c_int * 2 as libc::c_int) as libc::c_uint;
    output.write_cb = Some(
        _stdout_write_frames
            as unsafe extern "C" fn(
                _: crate::squeezelite_h::frames_t,
                _: bool,
                _: crate::squeezelite_h::s32_t,
                _: crate::squeezelite_h::s32_t,
                _: crate::squeezelite_h::s32_t,
                _: crate::squeezelite_h::s32_t,
                _: *mut *mut crate::squeezelite_h::s32_t,
            ) -> libc::c_int,
    );
    output.rate_delay = rate_delay;
    if !params.is_null() {
        if crate::stdlib::strcmp(params, b"32\x00" as *const u8 as *const libc::c_char) == 0 {
            output.format = crate::squeezelite_h::S32_LE
        }
        if crate::stdlib::strcmp(params, b"24\x00" as *const u8 as *const libc::c_char) == 0 {
            output.format = crate::squeezelite_h::S24_3LE
        }
        if crate::stdlib::strcmp(params, b"16\x00" as *const u8 as *const libc::c_char) == 0 {
            output.format = crate::squeezelite_h::S16_LE
        }
    }
    // ensure output rate is specified to avoid test open
    if *rates.offset(0 as libc::c_int as isize) == 0 {
        *rates.offset(0 as libc::c_int as isize) = 44100 as libc::c_int as libc::c_uint
    }
    crate::src::output::output_init_common(
        level,
        b"-\x00" as *const u8 as *const libc::c_char,
        output_buf_size,
        rates,
        0 as libc::c_int as libc::c_uint,
    );
    let mut attr = crate::stdlib::pthread_attr_t { __size: [0; 56] };
    crate::stdlib::pthread_attr_init(&mut attr);
    crate::stdlib::pthread_attr_setstacksize(
        &mut attr,
        (16384 as libc::c_int + 64 as libc::c_int * 1024 as libc::c_int) as crate::stddef_h::size_t,
    );
    crate::stdlib::pthread_create(
        &mut thread,
        &mut attr,
        ::std::mem::transmute::<
            Option<unsafe extern "C" fn() -> *mut libc::c_void>,
            Option<unsafe extern "C" fn(_: *mut libc::c_void) -> *mut libc::c_void>,
        >(Some(::std::mem::transmute::<
            unsafe extern "C" fn() -> *mut libc::c_void,
            unsafe extern "C" fn() -> *mut libc::c_void,
        >(output_thread))),
        0 as *mut libc::c_void,
    );
    crate::stdlib::pthread_attr_destroy(&mut attr);
}
/*
 *  Squeezelite - lightweight headless squeezebox emulator
 *
 *  (c) Adrian Smith 2012-2015, triode1@btinternet.com
 *      Ralph Irving 2015-2017, ralph_irving@hotmail.com
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Additions (c) Paul Hermann, 2015-2017 under the same license terms
 *   -Control of Raspberry pi GPIO for amplifier power
 *   -Launch script on power status change from LMS
 */
// make may define: PORTAUDIO, SELFPIPE, RESAMPLE, RESAMPLE_MP, VISEXPORT, GPIO, IR, DSD, LINKALL to influence build
// build detection
// dynamically loaded libraries at run time
// !LINKALL
// config options
// do not reduce as icy-meta max is 4080
/* SUN */
/* SUN */
// printf/scanf formats for u64_t
// logging
// utils.c (non logging)
// buffer.c
// _* called with mutex locked
// slimproto.c
// stream.c
// decode.c
// output.c output_alsa.c output_pa.c output_pack.c
// frames played at the point delay is measured
// ordered largest first so [0] is max_rate
// set in decode thread
// set in decode thread
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// set by slimproto
// _* called with mutex locked
// output_alsa.c
// output_pa.c
// output_pulse.c
// output_stdout.c
#[no_mangle]

pub unsafe extern "C" fn output_close_stdout() {
    if loglevel as libc::c_uint >= crate::squeezelite_h::lINFO as libc::c_int as libc::c_uint {
        crate::src::utils::logprint(
            b"%s %s:%d close output\n\x00" as *const u8 as *const libc::c_char,
            crate::src::utils::logtime(),
            (*::std::mem::transmute::<&[u8; 20], &[libc::c_char; 20]>(b"output_close_stdout\x00"))
                .as_ptr(),
            174 as libc::c_int,
        );
    }
    crate::stdlib::pthread_mutex_lock(&mut (*outputbuf).mutex);
    running = 0 as libc::c_int != 0;
    crate::stdlib::pthread_mutex_unlock(&mut (*outputbuf).mutex);
    crate::stdlib::free(buf as *mut libc::c_void);
    crate::src::output::output_close_common();
}
