extern "C" {
    #[no_mangle]
    pub fn _buf_used(buf: *mut crate::squeezelite_h::buffer) -> libc::c_uint;

    #[no_mangle]
    pub fn to_gain(f: libc::c_float) -> crate::squeezelite_h::s32_t;

    #[no_mangle]
    pub fn gain(
        gain_0: crate::squeezelite_h::s32_t,
        sample: crate::squeezelite_h::s32_t,
    ) -> crate::squeezelite_h::s32_t;

    #[no_mangle]
    pub fn _apply_cross(
        outputbuf_0: *mut crate::squeezelite_h::buffer,
        out_frames: crate::squeezelite_h::frames_t,
        cross_gain_in: crate::squeezelite_h::s32_t,
        cross_gain_out: crate::squeezelite_h::s32_t,
        cross_ptr: *mut *mut crate::squeezelite_h::s32_t,
    );

    #[no_mangle]
    pub fn _apply_gain(
        outputbuf_0: *mut crate::squeezelite_h::buffer,
        count: crate::squeezelite_h::frames_t,
        gainL: crate::squeezelite_h::s32_t,
        gainR: crate::squeezelite_h::s32_t,
    );
}
// =============== BEGIN squeezelite_h ================
pub type s16_t = crate::stdlib::int16_t;
#[repr(C)]
#[derive(Copy, Clone)]
pub union C2RustUnnamed_1 {
    pub pause_frames: crate::squeezelite_h::u32_t,
    pub skip_frames: crate::squeezelite_h::u32_t,
    pub start_at: crate::squeezelite_h::u32_t,
}
pub type u32_t = crate::stdlib::u_int32_t;
pub type u64_t = crate::stdlib::u_int64_t;
pub type s32_t = crate::stdlib::int32_t;
pub type frames_t = crate::squeezelite_h::u32_t;
pub type log_level = libc::c_uint;
pub type stream_state = libc::c_uint;
pub type disconnect_code = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct streamstate {
    pub state: crate::squeezelite_h::stream_state,
    pub disconnect: crate::squeezelite_h::disconnect_code,
    pub header: *mut libc::c_char,
    pub header_len: crate::stddef_h::size_t,
    pub sent_headers: bool,
    pub cont_wait: bool,
    pub bytes: crate::squeezelite_h::u64_t,
    pub threshold: libc::c_uint,
    pub meta_interval: crate::squeezelite_h::u32_t,
    pub meta_next: crate::squeezelite_h::u32_t,
    pub meta_left: crate::squeezelite_h::u32_t,
    pub meta_send: bool,
}
pub type decode_state = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct decodestate {
    pub state: crate::squeezelite_h::decode_state,
    pub new_stream: bool,
    pub mutex: crate::stdlib::pthread_mutex_t,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct codec {
    pub id: libc::c_char,
    pub types: *mut libc::c_char,
    pub min_read_bytes: libc::c_uint,
    pub min_space: libc::c_uint,
    pub open: Option<
        unsafe extern "C" fn(
            _: crate::squeezelite_h::u8_t,
            _: crate::squeezelite_h::u8_t,
            _: crate::squeezelite_h::u8_t,
            _: crate::squeezelite_h::u8_t,
        ) -> (),
    >,
    pub close: Option<unsafe extern "C" fn() -> ()>,
    pub decode: Option<unsafe extern "C" fn() -> crate::squeezelite_h::decode_state>,
}
pub type fade_mode = libc::c_uint;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct outputstate {
    pub state: crate::squeezelite_h::output_state,
    pub format: crate::squeezelite_h::output_format,
    pub device: *const libc::c_char,
    pub buffer: libc::c_uint,
    pub period: libc::c_uint,
    pub track_started: bool,
    pub write_cb: Option<
        unsafe extern "C" fn(
            _: crate::squeezelite_h::frames_t,
            _: bool,
            _: crate::squeezelite_h::s32_t,
            _: crate::squeezelite_h::s32_t,
            _: crate::squeezelite_h::s32_t,
            _: crate::squeezelite_h::s32_t,
            _: *mut *mut crate::squeezelite_h::s32_t,
        ) -> libc::c_int,
    >,
    pub start_frames: libc::c_uint,
    pub frames_played: libc::c_uint,
    pub frames_played_dmp: libc::c_uint,
    pub current_sample_rate: libc::c_uint,
    pub supported_rates: [libc::c_uint; 18],
    pub default_sample_rate: libc::c_uint,
    pub error_opening: bool,
    pub device_frames: libc::c_uint,
    pub updated: crate::squeezelite_h::u32_t,
    pub track_start_time: crate::squeezelite_h::u32_t,
    pub current_replay_gain: crate::squeezelite_h::u32_t,
    pub c2rust_unnamed: crate::squeezelite_h::C2RustUnnamed_1,
    pub next_sample_rate: libc::c_uint,
    pub track_start: *mut crate::squeezelite_h::u8_t,
    pub gainL: crate::squeezelite_h::u32_t,
    pub gainR: crate::squeezelite_h::u32_t,
    pub invert: bool,
    pub next_replay_gain: crate::squeezelite_h::u32_t,
    pub threshold: libc::c_uint,
    pub fade: crate::squeezelite_h::fade_state,
    pub fade_start: *mut crate::squeezelite_h::u8_t,
    pub fade_end: *mut crate::squeezelite_h::u8_t,
    pub fade_dir: crate::squeezelite_h::fade_dir,
    pub fade_mode: crate::squeezelite_h::fade_mode,
    pub fade_secs: libc::c_uint,
    pub rate_delay: libc::c_uint,
    pub delay_active: bool,
    pub stop_time: crate::squeezelite_h::u32_t,
    pub idle_to: crate::squeezelite_h::u32_t,
}
pub type fade_dir = libc::c_uint;
pub type fade_state = libc::c_uint;
pub type output_format = libc::c_uint;
pub type output_state = libc::c_int;
pub type s64_t = crate::stdlib::int64_t;
pub const lSDEBUG: crate::squeezelite_h::log_level = 4;
pub const lDEBUG: crate::squeezelite_h::log_level = 3;
pub const lINFO: crate::squeezelite_h::log_level = 2;
pub const lWARN: crate::squeezelite_h::log_level = 1;
pub const lERROR: crate::squeezelite_h::log_level = 0;
pub const RECV_HEADERS: crate::squeezelite_h::stream_state = 7;
pub const SEND_HEADERS: crate::squeezelite_h::stream_state = 6;
pub const STREAMING_HTTP: crate::squeezelite_h::stream_state = 5;
pub const STREAMING_FILE: crate::squeezelite_h::stream_state = 4;
pub const STREAMING_BUFFERING: crate::squeezelite_h::stream_state = 3;
pub const STREAMING_WAIT: crate::squeezelite_h::stream_state = 2;
pub const DISCONNECT: crate::squeezelite_h::stream_state = 1;
pub const STOPPED: crate::squeezelite_h::stream_state = 0;
pub const TIMEOUT: crate::squeezelite_h::disconnect_code = 4;
pub const UNREACHABLE: crate::squeezelite_h::disconnect_code = 3;
pub const REMOTE_DISCONNECT: crate::squeezelite_h::disconnect_code = 2;
pub const LOCAL_DISCONNECT: crate::squeezelite_h::disconnect_code = 1;
pub const DISCONNECT_OK: crate::squeezelite_h::disconnect_code = 0;
pub const DECODE_ERROR: crate::squeezelite_h::decode_state = 4;
pub const DECODE_COMPLETE: crate::squeezelite_h::decode_state = 3;
pub const DECODE_RUNNING: crate::squeezelite_h::decode_state = 2;
pub const DECODE_READY: crate::squeezelite_h::decode_state = 1;
pub const DECODE_STOPPED: crate::squeezelite_h::decode_state = 0;
pub const FADE_INOUT: crate::squeezelite_h::fade_mode = 4;
pub const FADE_OUT: crate::squeezelite_h::fade_mode = 3;
pub const FADE_IN: crate::squeezelite_h::fade_mode = 2;
pub const FADE_CROSSFADE: crate::squeezelite_h::fade_mode = 1;
pub const FADE_NONE: crate::squeezelite_h::fade_mode = 0;
pub const FADE_CROSS: crate::squeezelite_h::fade_dir = 3;
pub const FADE_DOWN: crate::squeezelite_h::fade_dir = 2;
pub const FADE_UP: crate::squeezelite_h::fade_dir = 1;
pub const FADE_ACTIVE: crate::squeezelite_h::fade_state = 2;
pub const FADE_DUE: crate::squeezelite_h::fade_state = 1;
pub const FADE_INACTIVE: crate::squeezelite_h::fade_state = 0;
pub const S16_LE: crate::squeezelite_h::output_format = 3;
pub const S24_3LE: crate::squeezelite_h::output_format = 2;
pub const S24_LE: crate::squeezelite_h::output_format = 1;
pub const S32_LE: crate::squeezelite_h::output_format = 0;
pub const OUTPUT_START_AT: crate::squeezelite_h::output_state = 5;
pub const OUTPUT_SKIP_FRAMES: crate::squeezelite_h::output_state = 4;
pub const OUTPUT_PAUSE_FRAMES: crate::squeezelite_h::output_state = 3;
pub const OUTPUT_RUNNING: crate::squeezelite_h::output_state = 2;
pub const OUTPUT_BUFFER: crate::squeezelite_h::output_state = 1;
pub const OUTPUT_STOPPED: crate::squeezelite_h::output_state = 0;
pub const OUTPUT_OFF: crate::squeezelite_h::output_state = -1;
pub type u16_t = crate::stdlib::u_int16_t;
pub type sockfd = libc::c_int;
pub type event_type = libc::c_uint;
pub const EVENT_WAKE: crate::squeezelite_h::event_type = 2;
pub const EVENT_READ: crate::squeezelite_h::event_type = 1;
pub const EVENT_TIMEOUT: crate::squeezelite_h::event_type = 0;
pub type u8_t = crate::stdlib::u_int8_t;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct buffer {
    pub buf: *mut crate::squeezelite_h::u8_t,
    pub readp: *mut crate::squeezelite_h::u8_t,
    pub writep: *mut crate::squeezelite_h::u8_t,
    pub wrap: *mut crate::squeezelite_h::u8_t,
    pub size: crate::stddef_h::size_t,
    pub base_size: crate::stddef_h::size_t,
    pub mutex: crate::stdlib::pthread_mutex_t,
}
